#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu May 11 20:24:20 2023

@author: fjunier
"""

import turtle  # indispensable pour redéfinir turtle dans nsi_ui
from nsi_ui import *
import random

PAS = 100
grille = [[0 for _ in range(4)] for __ in range(4)]
grille[2][1] = 8

def afficher_grille():
    up()
    for lig in range(4):
        for col in range(4):
            goto(col * PAS + PAS / 2, lig * PAS)
            down()
            write_text(f"{grille[lig][col]:^4}")
            up()

def decalage_droite():
    print("decalage")
    for i in range(4):
        grille[i][0] = 0
        for j in range(3, 0, -1):
            grille[i][j] = grille[i][j - 1]
    clear()
    afficher_grille()

def decalage_gauche():
    print("decalage")
    for i in range(4):
        for j in range(0, 3):
            grille[i][j] = grille[i][j + 1]
        grille[i][3] = 0
    clear()
    afficher_grille()

def nombre_alea():
    vides = [(i, j) for i in range(4) for j in range(4) if grille[i][j] == 0]
    ic, jc =random.choice(vides)
    grille[ic][jc] = [2, 4][random.randint(0, 1)]
    clear()
    afficher_grille()

# voir https://docs.python.org/3/library/turtle.html pour les fonctions turtle
# vous pouvez rajouter celles qui manquent dans nsi_ui après la ligne 452
# au même niveau d'indentation que def setworldcoordinates(llx, lly, urx, ury):

setworldcoordinates(0, 0, 4 * PAS + PAS / 2, 4 * PAS - PAS / 2)
hideturtle()  # cacher la tortue
set_size('50') # taille de police
speed(0)    # vitesse maximale de la tortie
afficher_grille()
onkey(decalage_droite, "Right")  #écouteur d'événement : si appui sur flèche Droite alors exécution de la fonction de rappel decalage_droite
onkey(decalage_gauche, "Left") #écouteur d'événement : si appui sur flèche Gauche alors exécution de la fonction de rappel decalage_gauche
animate(nombre_alea, 4000)     #appel de la fonction nombre_alea toutes les 4000 ms = 4 s

main_loop()
